;------------------------------------------------------------------------------
;  Copyright (c) KEIL ELEKTRONIK GmbH and Franklin Software, Inc., 1987-1992
;------------------------------------------------------------------------------
;/* Intel 80C51GB Processor Declarations */

;/******** BYTE Registers ********/
P0   	DATA	080H
P1   	DATA	090H
P2   	DATA	0A0H
P3   	DATA	0B0H
PSW  	DATA	0D0H
ACC  	DATA	0E0H
B    	DATA	0F0H
SP   	DATA	081H
DPL  	DATA	082H
DPH  	DATA	083H
PCON 	DATA	087H
TCON 	DATA	088H
TMOD 	DATA	089H
TL0  	DATA	08AH
TL1  	DATA	08BH
TH0  	DATA	08CH
TH1  	DATA	08DH
IE   	DATA	0A8H
IP   	DATA	0B8H
SCON 	DATA	098H
SBUF 	DATA	099H

;/********  80C51GB Specific Extensions ********/
SADDR 	DATA	0A9H
SADEN 	DATA	0B9H
T2CON 	DATA	0C8H
T2MOD 	DATA	0C9H
RCAP2L	DATA	0CAH
RCAP2H	DATA	0CBH
TL2   	DATA	0CCH
TH2   	DATA	0CDH
P4    	DATA	0C0H
ADRES0	DATA	084H
ADRES1	DATA	094H
ADRES2	DATA	0A4H
ADRES3	DATA	0B4H
ADRES4	DATA	0C4H
ADRES5	DATA	0D4H
ADRES6	DATA	0E4H
ADRES7	DATA	0F4H
AUXR  	DATA	08EH
OFDCON	DATA	0A5H
IPA1  	DATA	0B5H
WDTCON	DATA	0A6H
IPA   	DATA	0B6H
EXICON	DATA	0C6H
ADCON 	DATA	097H
IEA   	DATA	0A7H
IP1   	DATA	0B7H
ACMP  	DATA	0C7H
SEPCON	DATA	0D7H
SEPDAT	DATA	0E7H
SEPSTA	DATA	0F7H
P5    	DATA	0F8H

;/******** PCA0 SFRS ********/
CCON  	DATA	0D8H
CMOD  	DATA	0D9H
CCAPM0	DATA	0DAH
CCAPM1	DATA	0DBH
CCAPM2	DATA	0DCH
CCAPM3	DATA	0DDH
CCAPM4	DATA	0DEH
CL    	DATA	0E9H
CCAP0L	DATA	0EAH
CCAP1L	DATA	0EBH
CCAP2L	DATA	0ECH
CCAP3L	DATA	0EDH
CCAP4L	DATA	0EEH
CH    	DATA	0F9H
CCAP0H	DATA	0FAH
CCAP1H	DATA	0FBH
CCAP2H	DATA	0FCH
CCAP3H	DATA	0FDH
CCAP4H	DATA	0FEH

;/******** PCA1 SFRS *******/
C1CON  	DATA	0E8H
C1MOD  	DATA	09FH
C1CAPM0	DATA	09AH
C1CAPM1	DATA	09BH
C1CAPM2	DATA	09CH
C1CAPM3	DATA	09DH
C1CAPM4	DATA	09EH
CL1    	DATA	0AFH
C1CAP0L	DATA	0AAH
C1CAP1L	DATA	0ABH
C1CAP2L	DATA	0ACH
C1CAP3L	DATA	0ADH
C1CAP4L	DATA	0AEH
CH1    	DATA	0BFH
C1CAP0H	DATA	0BAH
C1CAP1H	DATA	0BBH
C1CAP2H	DATA	0BCH
C1CAP3H	DATA	0BDH
C1CAP4H	DATA	0BEH

;/********  BIT Registers  ********/
;/*  PSW  */
CY   	BIT	0D7H
AC   	BIT	0D6H
F0   	BIT	0D5H
RS1  	BIT	0D4H
RS0  	BIT	0D3H
OV   	BIT	0D2H
P    	BIT	0D0H

;/*  TCON  */
TF1  	BIT	08FH
TR1  	BIT	08EH
TF0  	BIT	08DH
TR0  	BIT	08CH
IE1  	BIT	08BH
IT1  	BIT	08AH
IE0  	BIT	089H
IT0  	BIT	088H

;/*  IE  */
EA   	BIT	0AFH
EC   	BIT	0AEH
ET2  	BIT	0ADH
ES   	BIT	0ACH
ET1  	BIT	0ABH
EX1  	BIT	0AAH
ET0  	BIT	0A9H
EX0  	BIT	0A8H

;/*  IP  */
PPC  	BIT	0BEH
PT2  	BIT	0BDH
PS   	BIT	0BCH
PT1  	BIT	0BBH
PX1  	BIT	0BAH
PT0  	BIT	0B9H
PX0  	BIT	0B8H

;/********  P1  Bits *******/
CEX4	BIT	097H
CEX3	BIT	096H
CEX2	BIT	095H
CEX1	BIT	094H
CEX0	BIT	093H
ECI 	BIT	092H
T2EX	BIT	091H
T2  	BIT	090H

;/********  P3  Bits ********/
RD  	BIT	0B7H
WR  	BIT	0B6H
T1  	BIT	0B5H
T0  	BIT	0B4H
INT1	BIT	0B3H
INT0	BIT	0B2H
TXD 	BIT	0B1H
RXD 	BIT	0B0H

;/********  P4  BITS *******/
C1EX4 	BIT	0C7H
C1EX3 	BIT	0C6H
C1EX2 	BIT	0C5H
C1EX1 	BIT	0C4H
C1EX0 	BIT	0C3H
C1    	BIT	0C2H
SEPIO 	BIT	0C1H
SEPCLK	BIT	0C0H

;/********  P5  BITS *******/
INT6  	BIT	0FEH
INT5  	BIT	0FDH
INT4  	BIT	0FCH
INT3  	BIT	0FBH
INT2  	BIT	0FAH

;/********  SCON  Bits  ********/
SM0  	BIT	09FH
SM1  	BIT	09EH
SM2  	BIT	09DH
REN  	BIT	09CH
TB8  	BIT	09BH
RB8  	BIT	09AH
TI   	BIT	099H
RI   	BIT	098H

;/******** T2CON BITS *******/
TF2  	BIT	0CFH 
EXF2 	BIT	0CEH
RCLK 	BIT	0CDH
TCLK 	BIT	0CCH
EXEN2	BIT	0CBH
TR2  	BIT	0CAH
CT2  	BIT	0C9H
CPRL2	BIT	0C8H

;/******** CCON BITS *******/
CF   	BIT	0DFH
CR   	BIT	0DEH
CCF4 	BIT	0DCH
CCF3 	BIT	0DBH
CCF2 	BIT	0DAH
CCF1 	BIT	0D9H
CCF0 	BIT	0D8H

;/******** CCON1 BITS *******/
CF1   	BIT	0EFH
CR1   	BIT	0EEH
CRE   	BIT	0EDH
C1CF4 	BIT	0ECH
C1CF3 	BIT	0EBH
C1CF2 	BIT	0EAH
C1CF1 	BIT	0E9H
C1CF0 	BIT	0E8H
