rms .?R,.?H,.?L,.?D,.?CY,.?SEL
rms .?D0, .?D1, .?D2, .?D3, .?D4, .?D5, .?D6, .?D7, .?OSEL
rmp ?80517?div16, ?80517?div32, ?80517?MUL16, ?80517?MD5, ?80517?ARCON
rmp ?80517?MD0, ?80517?MD1, ?80517?MD3, ?80517?MD4, ?80517?DPSEL, ?80517?reset
create .?R = 0
create .?H = 0
create .?L = 0
create .?D = 0
create .?CY = 0
create .?SEL = 0
create .?D0 = 0
create .?D1 = 0
create .?D2 = 0
create .?D3 = 0
create .?D4 = 0
create .?D5 = 0
create .?D6 = 0
create .?D7 = 0
create .?OSEL = 0

ws d w ?80517?MD1 0EAH
ws d w ?80517?MD3 0ECH
ws d w ?80517?MD4 0EDH
ws d w ?80517?MD5 0EEH
ws d w ?80517?ARCON 0EFH
ws d w ?80517?DPSEL 092H

define ?80517?DPSEL
  write 'SELECT DPTR ', dbyte 92h
  if .?OSEL = 0
    .?D0 = DPTR
  end
  if .?OSEL = 1
    .?D1 = DPTR
  end
  if .?OSEL = 2
    .?D2 = DPTR
  end
  if .?OSEL = 3
    .?D3 = DPTR
  end
  if .?OSEL = 4
    .?D4 = DPTR
  end
  if .?OSEL = 5
    .?D5 = DPTR
  end
  if .?OSEL = 6
    .?D6 = DPTR
  end
  if .?OSEL = 7
    .?D7 = DPTR
  end
  .?OSEL = dbyte 92h
  if (dbyte 92h) = 0
    set dptr, .?D0
  end
  if (dbyte 92h) = 1
    set dptr, .?D1
  end
  if (dbyte 92h) = 2
    set dptr, .?D2
  end
  if (dbyte 92h) = 3
    set dptr, .?D3
  end
  if (dbyte 92h) = 4
    set dptr, .?D4
  end
  if (dbyte 92h) = 5
    set dptr, .?D5
  end
  if (dbyte 92h) = 6
    set dptr, .?D6
  end
  if (dbyte 92h) = 7
    set dptr, .?D7
  end
endp

define ?80517?ARCON
  .?L = (dbyte 0e9h) + 100H * (dbyte 0eah)
  .?H = (dbyte 0ebh) + 100H * (dbyte 0ech)
  if ((dbyte 0efh) AND 1FH) = 0                ; Normalize
    write '80517 ALU: 32-Bit Normalize'
    if ((.?H = 0) AND (.?L = 0)) OR (.?H >= 8000H)
      set dbyte 0efH, (dbyte 0efH) OR 40h    ; Error Condition
    end
    while .?H < 8000h
      set dbyte 0efh, (dbyte 0efh) + 1
      .?H = .?H * 2
      if .?L >= 8000h
        .?H = .?H + 1
      end
      .?L = .?L * 2
    end
  elseif (dbyte 0efh) AND 20h                  ; Shift right
    write '80517 ALU: 32-Bit Shift Right; Cnt: ' (dbyte 0efH) AND 1FH
    count ((dbyte 0efh) AND 1FH)
      .?L = .?L / 2
      if (.?H AND 1)
        .?L = .?L + 8000H
      end
      .?H = .?H / 2
    end
  elseif (dbyte 0efh) AND 3FH                 ; Shift left
    write '80517 ALU: 32-Bit Shift Left; Cnt: ' (dbyte 0efH) AND 1FH
    count ((dbyte 0efh) AND 1FH)
      .?H = .?H * 2
      if .?L >= 8000h
        .?H = .?H + 1
      end
      .?L = .?L * 2
    end
  end
  set dbyte (0e9h), .?L AND 0FFH
  set dbyte (0eah), .?L / 100H
  set dbyte (0ebh), .?H AND 0FFH
  set dbyte (0ech), .?H / 100H
endp


define ?80517?MD0
  .?SEL = 0
endp

define ?80517?MD1
  .?SEL = 1
endp

define ?80517?MD3
  .?SEL = 3
endp

define ?80517?MD4
  if .?SEL < 3
    .?SEL = 4
  end
endp

define ?80517?MD5
  if .?SEL = 1
    call ?80517?mul16
  end
  if .?SEL = 3
    call ?80517?div32
  end
  if .?SEL = 4
    call ?80517?div16
  end
endp


define ?80517?mul16
  write '80517 ALU: 16-Bit Mul'
  .?L = (dbyte 0e9h) + 100H * (dbyte 0eah)
  .?D = (dbyte 0edh) + 100H * (dbyte 0eeh)
  .?R = (dbyte 0eah) * (dbyte 0edh) + (dbyte 0eeh) * (dbyte 0e9h)
  .?R = .?R / 100H + (dbyte 0eah) * (dbyte 0eeh)
  if .?R <> 0
    set dbyte 0efH, (dbyte 0efH) OR 40h    ; Error Condition
  end
  set dbyte 0e9h, (.?L * .?D) AND 0FFH
  set dbyte 0eah, (.?L * .?D) / 100H
  set dbyte 0ebh, .?R AND 0FFH
  set dbyte 0ech, .?R / 100H
endp


define ?80517?div16                        ; 16 Bit Division for the 80517
  write '80517 ALU: 16-Bit Div'
  .?L = (dbyte 0e9h) + 100H * (dbyte 0eah)
  .?D = (dbyte 0edh) + 100H * (dbyte 0eeh)
  if .?D = 0
    set dbyte 0efH, (dbyte 0efH) OR 40h    ; Error Condition
  end
  .?R = .?L / .?D
  .?L = .?L MOD .?D
  set dbyte (0e9h), .?L AND 0FFH
  set dbyte (0eah), .?L / 100H
  set dbyte (0edh), .?R AND 0FFH
  set dbyte (0eeh), .?R / 100H
endp

define ?80517?div32                        ; 32 Bit Division for the 80517
  write '80517 ALU: 32-Bit Div'
  .?L = (dbyte 0e9h) + 100H * (dbyte 0eah)
  .?H = (dbyte 0ebh) + 100H * (dbyte 0ech)
  .?D = (dbyte 0edh) + 100H * (dbyte 0eeh)
  if .?D = 0
    set dbyte 0efH, (byte 0efH) OR 40h     ; Error Condition
  end
  .?R = 0
  count 20H                                ; Loop
    .?CY = (.?R >= 8000H)
    .?R = .?R * 2
    if .?H >= 8000H
      .?R = .?R + 1
    end
    .?H = .?H * 2
    if .?L >= 8000H
      .?H = .?H + 1
    end
    .?L = .?L * 2
    if .?CY OR (.?R > .?D)
      .?R = .?R - .?D
      .?L = .?L + 1
    end
  end
  set dbyte (0e9h), .?L AND 0FFH
  set dbyte (0eah), .?L / 100H
  set dbyte (0ebh), .?H AND 0FFH
  set dbyte (0ech), .?H / 100H
  set dbyte (0edh), .?R AND 0FFH
  set dbyte (0eeh), .?R / 100H
endp


define ?80517?reset
  .OSEL = 0
endp
