/****************************************************************************/
/*             This file is part of the C-51 Compiler package               */
/*           Copyright (c) Franklin Software, Inc.  1989 - 1991             */
/****************************************************************************/
/*                                                                          */
/*  PUTCHAR.C:  This routine is the general character output routine        */
/*  available in, and used by the C-51 libraries.  Be sure to use the       */
/*  correct "register.h" file.                                              */
/*                                                                          */
/*  Compile this file with the following invocation:                        */
/*                                                                          */
/*     C51 PUTCHAR.C                                                        */
/*                                                                          */
/*  To link the modified PUTCHAR.OBJ file into your application use this    */
/*  L51 invocation:                                                         */
/*                                                                          */
/*     L51 <your object file list>, PUTCHAR.OBJ <controls>                  */
/*                                                                          */
/****************************************************************************/

#include <reg51.h>

#define XON  0x11
#define XOFF 0x13

char putchar (char c)  {

  if (c == '\n')  {
    if (RI)  {
      if (SBUF == XOFF)  {
        do  {
          RI = 0;
          while (!RI);
        }
        while (SBUF != XON);
        RI = 0; 
      }
    }
    while (!TI);
    TI = 0;
    SBUF = 0x0d;                         /* output CR  */
  }
  if (RI)  {
    if (SBUF == XOFF)  {
      do  {
        RI = 0;
        while (!RI);
      }
      while (SBUF != XON);
      RI = 0; 
    }
  }
  while (!TI);
  TI = 0;
  return (SBUF = c);
}
