/*  Filename     J31EX2.C
    Description  JAZZ-31 Example 2
    Hardware     JAZZ-31 Board
    Compiler     Franklin v3.2
    Engineer     Kriangsak B.
    Company      Sila Research Co.,Ltd. */

#include <reg52.h>
#include <absacc.h>
#include <ctype.h>
#include <intrins.h>
#include <math.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SEGM   XBYTE [0xf800]
#define DIGIT  XBYTE [0xf801]

/********** FUNCTION **********/

void dmsec(unsigned int count) {  /* Delay mSec */
    unsigned char i;
    while (count) {
        for (i=1;i<=113;i++);
        count--;
    }
}

void sound(unsigned char freq,int time) {
    unsigned char i;
    while (time>0) {
        DIGIT = DIGIT & 0x7f;     /* out signal low */
        for (i=1;i<=freq;i++)
            time--;
        DIGIT = DIGIT | 0x80;     /* out signal high */
        for (i=1;i<=freq;i++)
            time--;
    }
}

/********** MAIN **********/

void main(void) {
    unsigned char i,j;
    while (1) {
        j = 200;
        for (i=1;i<=16;i++) {
            sound (j,5000);
            dmsec (100);
            j = j - 10;
        }
    }
}


